=== client/CMakeLists.txt ===
set(client_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/clientlauncher.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/tile.cpp
	PARENT_SCOPE
)
