=== debian/changelog ===
minetest (0.4.13+repack-1build1) xenial; urgency=medium

  * No-change rebuild for the libjsoncpp transition.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 10 Feb 2016 10:57:54 +0100

minetest (0.4.13+repack-1) unstable; urgency=medium

  * New upstream release.
  * Drop the following patches.
    - FindIrrlicht.cmake.patch, merged upstream.
    - FindJson.cmake.patch, upstream added -DENABLE_SYSTEM_JSONCPP=1
  * Fix freetype2 include dir variable name as per README.txt.
    Patch from Robert Bruce Park (Closes: #794823).

 -- Martin Quinson <mquinson@debian.org>  Thu, 20 Aug 2015 23:55:30 +0200
