=== debian/watch ===
version=3
opts=dversionmangle=s/\+(repack|dfsg|ds|deb)\d*$// \
https://github.com/minetest/minetest/tags .*/(\d[\d\.]+)\.tar\.gz
